// AtatchDownload.cpp :  Դϴ.
//

#include "stdafx.h"
#include "NeMessenger.h"
#include "AtatchDownload.h"

// CAtatchDownload ȭ Դϴ.

IMPLEMENT_DYNCREATE(CAtatchDownload, CDialog)

UINT CAtatchDownload::_DownloadThread(LPVOID pParam)
{
	CAtatchDownload* pDlg = (CAtatchDownload*) pParam;
	ASSERT(pDlg);
	if (pDlg == NULL)
		return 0;
	ASSERT(pDlg->IsKindOf(RUNTIME_CLASS(CAtatchDownload)));
	pDlg->m_updateManager.DownloadUpdateFiles(pParam);

	if (pDlg->IsOpenFolderAfterDownload())
		ShellExecute(0, 0, pDlg->m_strDownPath, 0, 0, SW_SHOWNORMAL);

	return 0;
}

CAtatchDownload::CAtatchDownload(CWnd* pParent /*=NULL*/)
	: CDialog(CAtatchDownload::IDD, pParent)
{
	m_pThread = NULL;

	m_nDownCnt = 0;

	m_dwTotalSize = 0;
	m_dwCurDownloadSize = 0;
	m_bOpenFolderAfterDownload = TRUE;

	m_strCurDownloadFileName = _T("");
	m_strDownPath = _T("");

	m_pImgBG = NULL;
	m_pImgProgressBG = NULL;
	m_pImgProgressFG = NULL;

	m_crBG = DEF_FILE_DOWNLOAD_BG_COLOR;
	m_crOutline = DEF_FILE_DOWNLOAD_LINE_COLOR;

	m_strSendSpeedTitle = _T("");
	m_strSendSpeedValue = _T("");
	m_strRemainTimeTitle = _T("");
	m_strRemainTimeValue = _T("");
	m_strTotalSizeTitle = _T("");
	m_strTotalSizeValue = _T("");
	m_strProgressTitle = _T("");

	m_rtWnd.SetRectEmpty();
	m_rtSendSpeedTitle.SetRectEmpty();
	m_szSendSpeedTitle.SetSize(0, 0);
	m_rtSendSpeedValue.SetRectEmpty();
	m_rtRemainTimeTitle.SetRectEmpty();
	m_szRemainTimeTitle.SetSize(0, 0);
	m_rtRemainTimeValue.SetRectEmpty();
	m_rtTotalSizeTitle.SetRectEmpty();
	m_szTotalSizeTitle.SetSize(0, 0);
	m_rtTotalSizeValue.SetRectEmpty();
	m_rtProgressTitle.SetRectEmpty();
	m_szProgressTitle.SetSize(0, 0);
	m_rtProgressValue.SetRectEmpty();
	m_rtFileDownloadList.SetRectEmpty();
	m_rtBtnClose.SetRectEmpty();
	SetImgProgressPath(_T("MemoRecv_Progress_FG.png"), _T("MemoRecv_Progress_BG.png"));
	SetFontConfig(g_defaultFontFaceName, 9, FontStyleRegular, Color(255, 34, 34, 34));
	
	CString strTitle;
	strTitle.LoadString(IDS_ATTACHDOWNLOAD_SENDSPPED);
	SetSendSpeedTitle(strTitle);
	strTitle.LoadString(IDS_ATTACHDOWNLOAD_REMAINTIME);
	SetRemainTimeTitle(strTitle);
	strTitle.LoadString(IDS_ATTACHDOWNLOAD_TOTALSIZE);
	SetTotalSizeTitle(strTitle);
	strTitle.LoadString(IDS_ATTACHDOWNLOAD_PROGRESS);
	SetProgressTitle(strTitle);
    //m_nHitTest = 0;
    //m_nBorderHeight = 0;
    //m_nBorderWidth = 0;
}

CAtatchDownload::~CAtatchDownload()
{
    //Release in OnDestroy
    ASSERT(NULL == m_pThread);
    ASSERT(NULL == m_pImgBG); 
    ASSERT(NULL == m_pImgProgressBG);
}//lint !e1540

void CAtatchDownload::SetImgBGPath(CString strFileName)
{
	CString strImgPath = _T(""), strImgDir = _T("");

	strImgDir = GetAppImgDir();

	if (strFileName.IsEmpty())
		return;
	strImgPath.Format(_T("%s\\%s"), strImgDir, strFileName);

	m_pImgBG = new Image(strImgPath);
}

void CAtatchDownload::SetImgProgressPath(CString strFileNameFG, CString strFileNameBG)
{
	CString strImgPath = _T(""), strImgDir = _T("");

	strImgDir = GetAppImgDir();

	if (strFileNameFG.IsEmpty())
		return;
	strImgPath.Format(_T("%s\\%s"), strImgDir, strFileNameFG);

	m_pImgProgressFG = new Image(strImgPath);

	if (strFileNameBG.IsEmpty())
		return;
	strImgPath.Format(_T("%s\\%s"), strImgDir, strFileNameBG);

	m_pImgProgressBG = new Image(strImgPath);
}

void CAtatchDownload::SetFontConfig(WCHAR* wszFontName, REAL nFontHeight, FontStyle style, Color crText)
{
    _tcsncpy(m_wszFontName, wszFontName, _countof(m_wszFontName)-1 );
	//_tcscpy_s(m_wszFontName, wszFontName);
	m_nFontHeight = nFontHeight;
	m_fontStyle = style;

	m_crText = crText;
}

void CAtatchDownload::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);	
	DDX_Control(pDX, IDC_LIST_FILES, m_listFiles);	
	DDX_Control(pDX, IDOK, m_btnClose);	
}

BOOL CAtatchDownload::OnInitDialog()
{
	CDialog::OnInitDialog();

	SetSkin();
	ModifyStyle(0, WS_CLIPCHILDREN);
	ModifyStyle(DS_MODALFRAME, WS_THICKFRAME);
	
	CString strTitle;
	strTitle.LoadString(IDS_ATTACHDOWNLOAD_WINDOWTITLE);
	SetWindowText(strTitle);

	CImageList imgList;
	imgList.Create(1, DEF_ATTACH_LIST_ITEM_HEIGHT, ILC_COLORDDB, 1, 0);
	m_listFiles.SetImageList(&imgList, LVSIL_SMALL);

	m_listFiles.SetImgProgressPath(_T("MemoSend_Progress_FG.png"), _T("MemoSend_Progress_BG.png"));
	m_listFiles.SetImgFilePath(_T("MemoSend_Attach_File.png"));
	m_listFiles.SetFontConfig(g_defaultFontFaceName, 9, FontStyleRegular, Color(255, 102, 102, 102));

	if (g_stNtalkInfo.nLang == NTALK_LANG_KOREAN) //kor
	{	
		strTitle.LoadString(IDS_STRING164);
		m_listFiles.InsertColumn(0, strTitle, LVCFMT_LEFT, 100);
		strTitle.LoadString(IDS_STRING165);
		m_listFiles.InsertColumn(1, strTitle, LVCFMT_LEFT, 100);
		strTitle.LoadString(IDS_TITLE_STATUS);
		m_listFiles.InsertColumn(2, strTitle, LVCFMT_LEFT, 70);		
	}
	else if (g_stNtalkInfo.nLang == NTALK_LANG_ENGLISH) //eng
	{
	}
	else if (g_stNtalkInfo.nLang == NTALK_LANG_JAPANESE)
	{
	}
	else if (g_stNtalkInfo.nLang == NTALK_LANG_CHINESE_TRADITIONAL)
	{
	}
	else if (g_stNtalkInfo.nLang == NTALK_LANG_CHINESE_SIMPLIFIED)
	{
	}

	UPDATEFILEINFO* pInfo = NULL;
	for (size_t i=0; i<m_updateManager.m_vecUpdateFileInfo.size(); i++)
	{
		pInfo = m_updateManager.m_vecUpdateFileInfo.at(i);
		if (pInfo)
		{
			if (pInfo->strFileName.IsEmpty())
				continue;

			m_listFiles.AddAttachItem(pInfo->strFileName, pInfo->nSize);
		}
	}

	m_btnClose.SetFont(&g_ftDefault13PX);

	strTitle.LoadString(IDS_TITLE_CLOSE);
	m_btnClose.SetWindowText(strTitle);

	ResizeCtrl();

	DoDownload();

	return TRUE;  // Ŀ Ʈѿ   TRUE ȯմϴ.
}

void CAtatchDownload::SetSkin()
{
	CXTPSkinManager* pSkinManager = XTPSkinManager();

	// LosdSkin()   ׸    .
	//  ׸ ϱ ؼ SetWindowsTheme  ̿ؾ .
	pSkinManager->ApplyWindow(GetSafeHwnd());
	CXTPSkinManagerSchema* pSchema = pSkinManager->CreateSchema(GetAppImgDir()+_T("\\style\\Ntalk.cjstyles"), _T("Base1.ini"));
	pSkinManager->SetWindowTheme(GetSafeHwnd(), pSchema);
	
	CMDTARGET_RELEASE(pSchema);
}

void CAtatchDownload::AddDownloadFile(CString strURL, CString strDownPath, CString strFileName, CString strSize)
{
	m_nDownCnt++;

	m_strDownPath = strDownPath;
	m_updateManager.AddDownloadFile(strURL, strDownPath, strFileName, strSize);
	char* szSize = StringToChar(strSize);

	if (NULL != szSize)
	{
		int nSize = atoi(szSize);
		delete [] szSize; szSize = NULL;
		m_dwTotalSize += nSize;
	}

	ULONGLONG dwRemainSize = m_dwTotalSize % 1024;
	ULONGLONG dwTotalSize = m_dwTotalSize / 1024;
	if (dwRemainSize > 0)
		dwTotalSize += 1;

	CString strTotalSize = _T("");
	strTotalSize.Format(_T("%d"), (INT)dwTotalSize);
	m_strTotalSizeValue = InsertCharToString(strTotalSize, 3, _T(','));
	m_strTotalSizeValue += _T("KB");

	if (!m_rtTotalSizeValue.IsRectEmpty())
		RedrawWindow(&m_rtTotalSizeValue, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ALLCHILDREN);
}

bool CAtatchDownload::DoDownload(void)
{
	if (m_updateManager.m_nTotalCnt <= 0)
	{
		NMessageBox(this, LoadStringFromResource(IDS_STRING154));
		return false;
	}

	m_pThread = AfxBeginThread(_DownloadThread, this, THREAD_PRIORITY_NORMAL, 0, CREATE_SUSPENDED);
	if (m_pThread == NULL)
	{
		TRACE(_T("Failed to create download thread, dialog is aborting\n"));	
		return false;
	}
	m_pThread->m_bAutoDelete = FALSE;
	m_pThread->ResumeThread();

	m_dtDownloadStart = COleDateTime::GetCurrentTime();

	return true;
}

BEGIN_MESSAGE_MAP(CAtatchDownload, CDialog)
	ON_WM_ERASEBKGND()
	ON_WM_PAINT()
	ON_WM_DESTROY()	
	ON_WM_SIZE()
	ON_BN_CLICKED(IDOK, &CAtatchDownload::OnBnClickedOk)
	ON_WM_GETMINMAXINFO()
END_MESSAGE_MAP()

BEGIN_DHTML_EVENT_MAP(CAtatchDownload)
END_DHTML_EVENT_MAP()

// CAtatchDownload ޽ óԴϴ.
void CAtatchDownload::OnDestroy()
{
	try
	{
		if (m_pThread)
		{
			TerminateThread(m_pThread->m_hThread, INFINITE);
			delete m_pThread;
			m_pThread = NULL;
		}
	}
	catch (...)
	{
		return CDialog::OnDestroy();
	}

	if (m_pImgBG)
	{
		delete m_pImgBG;
		m_pImgBG = NULL;
	}

	if (m_pImgProgressBG)
	{
		delete m_pImgProgressBG;
		m_pImgProgressBG = NULL;
	}
	if (m_pImgProgressFG)
	{
		delete m_pImgProgressFG;
		m_pImgProgressFG = NULL;
	}

	CDialog::OnDestroy();
}

BOOL CAtatchDownload::OnEraseBkgnd(CDC* pDC)
{
	return TRUE;
}

void CAtatchDownload::OnPaint()
{
	CPaintDC dc(this); // device context for painting

	PAINTSTRUCT ps = dc.m_ps;
	int psWidth = ps.rcPaint.right - ps.rcPaint.left;
	int psHeight = ps.rcPaint.bottom - ps.rcPaint.top;

	int nPX = ps.rcPaint.left;
	int nPY = ps.rcPaint.top;

	CRect rtPS(nPX, nPY, nPX + psWidth, nPY + psHeight);

	CRect rt(0, 0, 0, 0);
	GetClientRect(&rt);
	int nWndWidth = rt.Width();
	int nWndHeight = rt.Height();

	HDC hdc = dc.GetSafeHdc();

	HDC	hdcMemory = CreateCompatibleDC(hdc);

	if (hdcMemory == NULL)
		return;

	HBITMAP hbmpMem = CreateCompatibleBitmap(hdc, psWidth, psHeight);

	HGDIOBJ hbmpOld = ::SelectObject(hdcMemory,  hbmpMem);

	Graphics graph(hdcMemory);

	if (hbmpMem)
	{
		graph.SetSmoothingMode(SmoothingModeAntiAlias);
		graph.SetInterpolationMode(InterpolationModeHighQualityBicubic);
		graph.SetPageUnit(UnitPixel);

		ImageAttributes ImgAttr;

		SolidBrush brushBG(m_crBG);
		Pen penBG(m_crOutline, 1);
		int nSX = 0, nSY = 0, nCX = 0, nCY = 0;
		if (m_pImgBG)
			DrawImageToStretchHorz(&graph, m_pImgBG, &rtPS, &m_rtWnd, m_crBG, &ImgAttr);
		else
		{
			nSX = m_rtWnd.left - rtPS.left;
			nSY = m_rtWnd.top - rtPS.top;
            Pen pen(m_crBG);
			graph.DrawRectangle(&pen, 0, nSY, nWndWidth, nWndHeight);
			graph.FillRectangle(&brushBG, 0, nSY, nWndWidth, nWndHeight);

			graph.DrawLine(&penBG, nSX, nSY, psWidth, nSY);	// ֻ 
			graph.DrawLine(&penBG, nSX, nSY + nWndHeight - 48, psWidth, nSY + nWndHeight - 48);
		}

		Rect rtList(m_rtFileDownloadList.left - 1, m_rtFileDownloadList.top - 1, m_rtFileDownloadList.Width() + 1, m_rtFileDownloadList.Height() + 1);
		graph.DrawRectangle(&penBG, rtList);

		DrawDownloadTextInfo(graph, rtPS);

		DrawProgressBar(graph, rtPS, ImgAttr);

		BitBlt(dc.GetSafeHdc(), nPX, nPY, psWidth, psHeight, hdcMemory, 0, 0, SRCCOPY);

		::SelectObject(hdcMemory, hbmpOld);
		::DeleteObject(hbmpMem);
	}

	::DeleteDC(hdcMemory);
}

void CAtatchDownload::UpdateSpeedTime()
{
	COleDateTimeSpan dtElapsed = COleDateTime::GetCurrentTime() - m_dtDownloadStart;
	double fSeconds = dtElapsed.GetTotalSeconds();

	double fKBSec = 0;
	if (fSeconds > 0)
		fKBSec = ((double)m_dwCurDownloadSize / 1024) / fSeconds;

	m_strSendSpeedValue.Format(_T("%0.2f KB/s"), fKBSec);
	RedrawWindow(&m_rtSendSpeedValue, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ALLCHILDREN);

	ULONGLONG dwRemainSize = m_dwTotalSize - m_dwCurDownloadSize;

	int nSec = 0;
	if (fKBSec)
		nSec = (int)(((double)dwRemainSize / 1024.0) / fKBSec);

	int nHour = nSec / 3600;
	if (nHour)
		nSec = nSec - (nHour * 3600);

	int nMin = nSec / 60;
	if (nMin)
		nSec = nSec - (nMin * 60);

	COleDateTimeSpan dtRemain(0, nHour, nMin, nSec);
	m_strRemainTimeValue = dtRemain.Format(_T("%H:%M:%S"));
	RedrawWindow(&m_rtRemainTimeValue, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ALLCHILDREN);
}

LRESULT CAtatchDownload::DownloadBegin(WPARAM wParam, LPARAM lParam)
{
	int nSize = wParam;
	m_strCurDownloadFileName = (LPCTSTR)lParam;
	CString strTemp = _T("");

	for (int i = 0; i < m_listFiles.GetItemCount(); i++)
	{
		strTemp = m_listFiles.GetItemText(i, 0);
		if (strTemp == m_strCurDownloadFileName)
		{
			m_listFiles.SetItemText(i, 2, _T("0"));
			break;
		}
	}

	return 0L;
}

LRESULT CAtatchDownload::DownloadBytes(WPARAM wParam, LPARAM lParam)
{
	int nSize = lParam;

	ULONGLONG dwWriteSize = (ULONGLONG)wParam;
	m_dwCurDownloadSize += dwWriteSize;

	RedrawWindow(&m_rtProgressValue, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ALLCHILDREN);

	UpdateSpeedTime();

	CString strTemp = _T("");
	int nTotalSize = 0;
	CString KBsec = _T("");
	char* szSize = NULL;

	for (int i = 0; i < m_listFiles.GetItemCount(); i++)
	{
		strTemp = m_listFiles.GetItemText(i, 0);
		if (strTemp == m_strCurDownloadFileName)
		{
			m_listFiles.UpdateAttachItemSize(i, nSize);
			break;
		}
	}

	return 0L;
}

LRESULT CAtatchDownload::DownloadEnd(WPARAM wParam, LPARAM lParam)
{
	CString strFileName = _T("");
	CString strEndFileName = (LPCTSTR)lParam;
	
	CString strTemp = _T("");

	for (int i = 0; i < m_listFiles.GetItemCount(); i++)
	{
		strTemp = m_listFiles.GetItemText(i, 0);
		if (strTemp == strEndFileName)
		{
			m_listFiles.UpdateAttachItemStatus(i, CAttachDownloadList::EATTACH_COMPLETE);
			break;
		}
	}

	RedrawWindow(&m_rtProgressValue, NULL, RDW_INVALIDATE | RDW_UPDATENOW |  RDW_ALLCHILDREN);

	m_nDownCnt++;
	if (m_updateManager.m_nTotalCnt <= m_nDownCnt)
	{
		m_nDownCnt = m_updateManager.m_nTotalCnt;
	}

	return 0L;
}

void CAtatchDownload::ResizeCtrl(void)
{
	CRect rcClient(0, 0, 0, 0);
	GetClientRect(&rcClient);

	int nSX = 0, nSY = 0, nCX = 0, nCY = 0, nEX = 0, nEY = 0;

	CRect rtBound(0, 0, m_rtWnd.Width(), 1000);

	nSX = DEF_FILE_DOWNLOAD_SENDSPEED_LEFT_POS_X;
	nSY = DEF_FILE_DOWNLOAD_SENDSPEED_TOP_POS_Y;
	if (m_szSendSpeedTitle.cx == 0 && !m_strSendSpeedTitle.IsEmpty())
	{
		REAL nFontHeight = m_nFontHeight;
		RecalcTextRect(this, m_strSendSpeedTitle, m_wszFontName, nFontHeight, m_fontStyle, rtBound, m_szSendSpeedTitle);
	}
	nCX = m_szSendSpeedTitle.cx + 5;
	nCY = m_szSendSpeedTitle.cy;
	m_rtSendSpeedTitle.SetRect(nSX, nSY, nSX + nCX, nSY + nCY);

	nSX = DEF_FILE_DOWNLOAD_SENDSPEED_LEFT_POS_X;
	nSY = DEF_FILE_DOWNLOAD_PROGRESS_TOP_POS_Y;
	if (m_szProgressTitle.cx == 0 && !m_strSendSpeedTitle.IsEmpty())
	{
		REAL nFontHeight = m_nFontHeight;
		RecalcTextRect(this, m_strProgressTitle, m_wszFontName, nFontHeight, m_fontStyle, rtBound, m_szProgressTitle);
	}
	nCX = m_szProgressTitle.cx + 5;
	nCY = m_szProgressTitle.cy;
	m_rtProgressTitle.SetRect(nSX, nSY, nSX + nCX, nSY + nCY);

	nSX = m_rtSendSpeedTitle.right + DEF_FILE_DOWNLOAD_PROGRESS_GAP_POS_X;
	if (m_rtProgressTitle.right > m_rtSendSpeedTitle.right)
		nSX = m_rtProgressTitle.right + DEF_FILE_DOWNLOAD_PROGRESS_GAP_POS_X;
	nSY = DEF_FILE_DOWNLOAD_PROGRESS_TOP_POS_Y;
	nEX = m_rtWnd.right - DEF_FILE_DOWNLOAD_PROGRESS_RIGHT_POS_X;
	nCY = m_rtProgressTitle.Height();
	if (m_pImgProgressBG)
		nCY = m_pImgProgressBG->GetHeight();
	m_rtProgressValue.SetRect(nSX, nSY, nEX, nSY + nCY);

	nSX = m_rtProgressValue.left;
	nSY = m_rtSendSpeedTitle.top;
	nEX = DEF_FILE_DOWNLOAD_REMAINTIME_LEFT_POS_X;
	nCY = m_rtSendSpeedTitle.Height();
	m_rtSendSpeedValue.SetRect(nSX, nSY, nEX, nSY + nCY);

	nSX = DEF_FILE_DOWNLOAD_REMAINTIME_LEFT_POS_X;
	nSY = m_rtSendSpeedTitle.top;
	if (m_szRemainTimeTitle.cx == 0 && !m_strRemainTimeTitle.IsEmpty())
	{
		REAL nFontHeight = m_nFontHeight;
		RecalcTextRect(this, m_strRemainTimeTitle, m_wszFontName, nFontHeight, m_fontStyle, rtBound, m_szRemainTimeTitle);
	}
	nCX = m_szRemainTimeTitle.cx + 5;
	nCY = m_szRemainTimeTitle.cy;
	m_rtRemainTimeTitle.SetRect(nSX, nSY, nSX + nCX, nSY + nCY);

	nSX = m_rtRemainTimeTitle.right + DEF_FILE_DOWNLOAD_TITLEVALUE_GAP_POS_X;
	nSY = m_rtRemainTimeTitle.top;
	nCX = DEF_FILE_DOWNLOAD_REMAINTIME_WIDTH - m_rtRemainTimeTitle.Width() - DEF_FILE_DOWNLOAD_TITLEVALUE_GAP_POS_X;
	nCY = m_rtRemainTimeTitle.Height();
	m_rtRemainTimeValue.SetRect(nSX, nSY, nSX + nCX, nSY + nCY);

	nSX = m_rtWnd.right - DEF_FILE_DOWNLOAD_TOTALSIZE_TITLE_POS_X;
	nSY = m_rtRemainTimeValue.top;
	if (m_szTotalSizeTitle.cx == 0 && !m_strTotalSizeTitle.IsEmpty())
	{
		REAL nFontHeight = m_nFontHeight;
		RecalcTextRect(this, m_strTotalSizeTitle, m_wszFontName, nFontHeight, m_fontStyle, rtBound, m_szTotalSizeTitle);
	}
	nCX = m_szTotalSizeTitle.cx + 5;
	nCY = m_szTotalSizeTitle.cy;
	m_rtTotalSizeTitle.SetRect(nSX, nSY, nSX + nCX, nSY + nCY);

	nSX = m_rtTotalSizeTitle.right;
	nSY = m_rtTotalSizeTitle.top;
	nEX = m_rtWnd.right - DEF_FILE_DOWNLOAD_TOTALSIZE_RIGHT_POS_X;
	nCY = m_rtTotalSizeTitle.Height();
	m_rtTotalSizeValue.SetRect(nSX, nSY, nEX, nSY + nCY);

	if (m_listFiles.GetSafeHwnd())
	{
		nSX = DEF_FILE_DOWNLOAD_LIST_LEFT_POS_X;
		nSY = DEF_FILE_DOWNLOAD_LIST_TOP_POS_Y;
		nEX = m_rtWnd.right - DEF_FILE_DOWNLOAD_LIST_LEFT_POS_X;
		nEY = m_rtWnd.bottom - DEF_FILE_DOWNLOAD_BOTTOMLINE_POS_Y - DEF_FILE_DOWNLOAD_LIST_LINE_GAP_Y;
		m_rtFileDownloadList.SetRect(nSX, nSY, nEX, nEY);
		m_listFiles.MoveWindow(&m_rtFileDownloadList);

		int nListWidth = m_rtFileDownloadList.Width();
		int nWidthName = (DEF_FILE_DOWNLOAD_LIST_COLNAME_WIDTH_PCT * nListWidth) / 100;
		m_listFiles.SetColumnWidth(0, nWidthName);
		int nWidthSize = (DEF_FILE_DOWNLOAD_LIST_COLNAME_SIZE_PCT * nListWidth) / 100;
		m_listFiles.SetColumnWidth(1, nWidthSize);
		int nWidthStatus = nListWidth - (nWidthName + nWidthSize) - 5;
		m_listFiles.SetColumnWidth(2, nWidthStatus);
	}

	if (m_btnClose.GetSafeHwnd())
	{
		nSX = (m_rtWnd.Width() - DEF_FILE_DOWNLOAD_BUTTON_WIDTH) / 2;
		nSY = (m_rtWnd.Height() - DEF_FILE_DOWNLOAD_BOTTOMLINE_POS_Y + ((DEF_FILE_DOWNLOAD_BOTTOMLINE_POS_Y - DEF_FILE_DOWNLOAD_BUTTON_HEIGHT) / 2));
		nCX = DEF_FILE_DOWNLOAD_BUTTON_WIDTH;
		nCY = DEF_FILE_DOWNLOAD_BUTTON_HEIGHT;
		m_rtBtnClose.SetRect(nSX, nSY, nSX + nCX, nSY + nCY);
		m_btnClose.MoveWindow(&m_rtBtnClose);
	}
}

void CAtatchDownload::OnSize(UINT nType, int cx, int cy)
{
	CDialog::OnSize(nType, cx, cy);

	m_rtWnd.SetRect(0, 0, cx, cy);

	ResizeCtrl();
	RedrawWindow(NULL, NULL, RDW_INVALIDATE | RDW_UPDATENOW);
}

BOOL CAtatchDownload::PreTranslateMessage(MSG* pMsg)
{
	if (pMsg->message == WM_CLOSE)
	{
		OnOK();
		return TRUE;

	}

	if (pMsg->message == WM_KEYDOWN)
	{
		if (pMsg->wParam == VK_ESCAPE || pMsg->wParam == VK_RETURN)
		{
			return TRUE;
		}
	}

	return CDialog::PreTranslateMessage(pMsg);
}

void CAtatchDownload::DrawDownloadTextInfo( Graphics &graph, CRect rtPS )
{
	if (!m_strSendSpeedTitle.IsEmpty())
	{
		DrawTextToDest2(&graph,
			m_strSendSpeedTitle, &rtPS, &m_rtSendSpeedTitle,
			m_wszFontName, m_nFontHeight,
			StringAlignmentNear,
			m_fontStyle,
			m_crText);
	}

	if (!m_strSendSpeedValue.IsEmpty())
	{
		DrawTextToDest2(&graph,
			m_strSendSpeedValue, &rtPS, &m_rtSendSpeedValue,
			m_wszFontName, m_nFontHeight,
			StringAlignmentNear,
			m_fontStyle,
			m_crText);
	}

	if (!m_strRemainTimeTitle.IsEmpty())
	{
		DrawTextToDest2(&graph,
			m_strRemainTimeTitle, &rtPS, &m_rtRemainTimeTitle,
			m_wszFontName, m_nFontHeight,
			StringAlignmentNear,
			m_fontStyle,
			m_crText);
	}
	if (!m_strRemainTimeValue.IsEmpty())
	{
		DrawTextToDest2(&graph,
			m_strRemainTimeValue, &rtPS, &m_rtRemainTimeValue,
			m_wszFontName, m_nFontHeight,
			StringAlignmentNear,
			m_fontStyle,
			m_crText);
	}

	if (!m_strTotalSizeTitle.IsEmpty())
	{
		DrawTextToDest2(&graph,
			m_strTotalSizeTitle, &rtPS, &m_rtTotalSizeTitle,
			m_wszFontName, m_nFontHeight,
			StringAlignmentNear,
			m_fontStyle,
			m_crText);
	}
	if (!m_strTotalSizeValue.IsEmpty())
	{
		DrawTextToDest2(&graph,
			m_strTotalSizeValue, &rtPS, &m_rtTotalSizeValue,
			m_wszFontName, m_nFontHeight,
			StringAlignmentFar,
			m_fontStyle,
			m_crText);
	}

	if (!m_strProgressTitle.IsEmpty())
	{
		DrawTextToDest2(&graph,
			m_strProgressTitle, &rtPS, &m_rtProgressTitle,
			m_wszFontName, m_nFontHeight,
			StringAlignmentNear,
			m_fontStyle,
			m_crText);
	}
}

void CAtatchDownload::DrawProgressBar( Graphics &graph, CRect rtPS, ImageAttributes &ImgAttr )
{
	if (NULL == m_pImgProgressBG)
	{
		return;
	}

	DrawImageToStretchHorz(&graph, m_pImgProgressBG, &rtPS, &m_rtProgressValue, Color(255, 220, 224, 228), &ImgAttr);

	double fPctProgress = (double)m_dwCurDownloadSize / (double)m_dwTotalSize;
	CRect rtProgressFG = m_rtProgressValue;
	rtProgressFG.right = rtProgressFG.left + (LONG)(rtProgressFG.Width() * fPctProgress);

	if (m_pImgProgressFG)
		DrawImageToStretchHorz(&graph, m_pImgProgressFG, &rtPS, &rtProgressFG, Color(255, 141, 204, 249), &ImgAttr);			
}

void CAtatchDownload::OnBnClickedOk()
{	
	CDialog::OnOK();
}

void CAtatchDownload::SetFileRename( LPCTSTR strSrcName, LPCTSTR strDestName )
{

	CString strTemp;	
	for (int i = 0; i < m_listFiles.GetItemCount(); i++)
	{
		strTemp = m_listFiles.GetItemText(i, 0);
		if (strTemp.CompareNoCase(strSrcName) == 0)
		{
			m_listFiles.UpdateAttachItemFilename(i, strDestName);
			break;
		}
	}
}

void CAtatchDownload::OnGetMinMaxInfo(MINMAXINFO* lpMMI)
{
	lpMMI->ptMinTrackSize.x = DEF_MIN_ATTACH_SIZE_WIDTH;
	lpMMI->ptMinTrackSize.y = DEF_MIN_ATTACH_SIZE_HEIGHT;

	CDialog::OnGetMinMaxInfo(lpMMI);
}

void CAtatchDownload::SetOpenFolderAfterDownload(BOOL bOpen)
{
	m_bOpenFolderAfterDownload = bOpen;
}
